<template>
    <div>
      <canvas ref="canvasId" class="canvas-style" @mousedown="mouseDown" />
    </div> 
  </template>
  
  <script setup>
  import { ref, onMounted } from 'vue';
  import paper from 'paper';
  
  const path = ref(null);
  const scope = ref(null);
  const canvasId = ref(null);
  let tool = null;
  
  const reset = () => {
    scope.value.project.activeLayer.removeChildren();
  };
  
  const pathCreate = (scope) => {
    scope.activate();
    return new paper.Path({
      strokeColor: '#000000',
      strokeJoin: 'round',
      strokeWidth: 5,
    });
  };
  
  const createTool = (scope) => {
    scope.activate();
    return new paper.Tool();
  };
  
  const mouseDown = () => {
    // in order to access functions in nested tool
  
    // create drawing tool
    tool = createTool(scope.value);
    tool.onMouseDown = (event) => {
      // init path
      path.value = pathCreate(scope.value);
      // add point to path
      path.value.add(event.point);
    };
    tool.onMouseDrag = (event) => {
      path.value.add(event);
    };
    tool.onMouseUp = (event) => {
      // line completed
      path.value.add(event.point);
    };
  };
  
  onMounted(() => {
    scope.value = new paper.PaperScope();
    scope.value.setup(canvasId.value);
  });
  </script>
  
  <style scoped>
  @import '../../main.css';
  </style>
